<?php
// Own namespace
namespace Org\Mxchange\CoreFramework\Filesystem\Text;

// Import framework stuff
use Org\Mxchange\CoreFramework\Factory\Object\ObjectFactory;
use Org\Mxchange\CoreFramework\Filesystem\File\BaseTextFile;

// Import SPL stuff
use \SplFileInfo;

/**
 * A general text input file class
 *
 * @author		Roland Haeder <webmaster@ship-simu.org>
 * @version		0.0.0
 * @copyright	Copyright (c) 2007, 2008 Roland Haeder, 2009 - 2020 Core Developer Team
 * @license		GNU GPL 3.0 or any newer version
 * @link		http://www.ship-simu.org
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
abstract class BaseInputTextFile extends BaseTextFile {
	/**
	 * Protected constructor
	 *
	 * @param	$className	Name of the class
	 * @return	void
	 */
	protected function __construct (string $className) {
		// Call parent constructor
		parent::__construct($className);
	}

	/**
	 * Initializes this text file for reading
	 *
	 * @param	$infoInstance	An instance of a SplFileInfo class
	 * @return	void
	 */
	protected function initFile (SplFileInfo $infoInstance) {
		// Get a file i/o pointer instance
		$pointerInstance = ObjectFactory::createObjectByConfiguredName('text_file_input_class', array($infoInstance));

		// ... and set it here
		$this->setPointerInstance($pointerInstance);
	}

	/**
	 * Reads a line from currently referenced file
	 *
	 * @return	$data	Read data from referenced file
	 */
	public function readLine () {
	}

}
