<?php
// Own namespace
namespace Org\Mxchange\CoreFramework\Registry\Upgrade\Format\Lfdb;

// Import framework stuff
use Org\Mxchange\CoreFramework\Registry\BaseRegistry;
use Org\Mxchange\CoreFramework\Upgrade\Format\Database\UpgradeableDatabaseFormat;
use Org\Mxchange\CoreFramework\Upgrade\Format\RegisterableFormatUpgrade;

/**
 * A LocalFileDatabase database-format-upgrade registry
 *
 * @author		Roland Haeder <webmaster@ship-simu.org>
 * @version		0.0.0
 * @copyright	Copyright (c) 2007, 2008 Roland Haeder, 2009 - 2020 Core Developer Team
 * @license		GNU GPL 3.0 or any newer version
 * @link		http://www.ship-simu.org
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
class LocalFileDatabaseFormatUpgradeRegistry extends BaseRegistry implements RegisterableFormatUpgrade {
	/**
	 * Instance of this class
	 */
	private static $registryInstance = null;

	/**
	 * Protected constructor
	 *
	 * @return	void
	 */
	private function __construct () {
		// Call parent constructor
		parent::__construct(__CLASS__);
	}

	/**
	 * Singleton getter for self instance. This class has no factory pattern
	 * because here is no need for special parameters.
	 *
	 * @return	$registryInstance	Instance of this class
	 */
	public final static function getRegistry () {
		// Is an instance there?
		if (is_null(self::$registryInstance)) {
			// Not yet, so create one
			self::$registryInstance = new LocalFileDatabaseFormatUpgradeRegistry();
		} // END - if

		// Return the instance
		return self::$registryInstance;
	}

	/**
	 * Registers given format-upgrade class with this registry
	 *
	 * @param	$upgradeInstance	An instance of a UpgradeableDatabaseFormat class
	 * @return	void
	 * @todo	0% done
	 */
	public function registerFormatUpgrader (UpgradeableDatabaseFormat $upgradeInstance) {
		$this->partialStub();
	}

}
